
/************************************************************************/
/*                                                                      */
/*	File Mover - Does the grunt work for PLUG - FMOVER.C		*/
/*                                                                      */
/*	Version 1.0, July   1987					*/
/*	Version 1.2, August 1987					*/
/*                                                                      */
/*	Compiled under Lattice C version 3.20	(Large model -mls)	*/
/*                                                                      */
/*	Author: Lawrence E. Himes					*/
/*                                                                      */
/*	Rev 1.2 -  getmem() calls changed to malloc() for portability.	*/
/*		   Add dir_pl structure to remove reliance on getmem()	*/
/*		   "trick" during file move.				*/
/*                                                                      */
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "dglobal.h"
#include "dir.h"

  extern struct dir_pl *dpl;
  extern int	  totalde;
  char *clbuf;			/* Cluster buffer  */

/****************************************************************/
/*                                                              */
/*	fmover	 () - Scan FAT and move files to holes		*/
/*                                                              */
/****************************************************************/

fmover ()
{
  unsigned clu, tclu, maxclu, hole;
  int x, vfy, r, offset;
  struct dir *de;
  struct dir_ch *dch;

	clbuf = malloc (clsize);
	if (!clbuf) return Nomem;
	vfy = getvfy ();
	setvfy ();
	de = dpl[0].dp;
	maxclu = de->fcluster;
	r = 0;
	cprintf ("\n");
	for (clu = 2;	clu < maxclu  ;  clu++ )   {
		tclu = getfate (clu);
		if (tclu) continue;
		hole = 1;		/* Set init hole size */
		tclu = clu;
		for (  ; !(getfate (tclu+1)); tclu++, hole++ ) ;
		if (tclu >= maxclu) break;
		x = bestfit (hole, clu);
		if (x < 0) {		/* No Fit  */
			clu = tclu;	/* Rev 1.2 - forget call to putinfo */
			continue;
		}
		de = dpl[x].dp;
                offset = ((dpl[x].inx) * (sizeof (struct dir)) + 
			   sizeof (struct dir_ch *) + sizeof (unsigned int));
		dch = (struct dir_ch *) (((char *)de) - offset);
		r = putinfo (hole, clu, de, dch);
		if (r) break;
		dpl[x].dp = NULL;
	}
	if (!r) dumpfat (1);
	if (!vfy) rstvfy ();
	return r;
}


/****************************************************************/
/*                                                              */
/*	putinfo  () - Move a file				*/
/*                                                              */
/****************************************************************/

putinfo (hole, clu, de, dch)
  unsigned hole, clu;
  struct dir *de;
  struct dir_ch *dch;
{
  static int   cl_moved = 0;
  static int   cl_m	= 0;
  char name [14];
  int r = 0;
  unsigned s, c, sclu;

  /****************************************
	cprintf ("\nHole at cluster %u, Size = %u, ", clu, hole);
	if (!de) {
		cprintf ("No best fit");
		return 0;
	}
	gnde (de, name);
	cprintf ("%s fits, Size = %lu", name, de->fsize);
	cprintf (". Move it? ");
	s = toupper (getch());
	if (s != 'Y') return 0;
  ****************************************/

	if (!de) return 0;

	sclu = clu;			/* Save cluster */
	for (s = de->fcluster;	 ; clu++ )   {
		r = rdcluster (s, clbuf);
		if (!r) r = wtcluster (clu, clbuf);
		if (r) goto _end;
		cprintf ("\b\b\b\b\b%d", ++cl_moved);
		++cl_m;
		c = getfate (s);
		putfate ((c >= Cutoff ? c : clu+1), clu);
		putfate (0, s);
		if (c < Cutoff) s = c;
		else break;
	}
	de->fcluster = sclu;		/* Set new first cluster */
	r = absdio (1, drive, dch->dirent, dch->secno, 1);
	if ((!r) && (cl_m >  15)) { r = dumpfat (cl_m = 0); }
_end:	return r;
}

